from sqlalchemy import *
meta = MetaData()


company = Table('company', meta,
    Column('symbol', String, primary_key=True, nullable=False),
    Column('sector', String, nullable=False),
    Column('industry', String, nullable=False),
    Column('company', String, nullable=False),
    Column('url', String, nullable=True),
)
company_ix_company  = Index('company_ix_company',  company.c.company, postgresql_using='hash')
company_ix_industry = Index('company_ix_industry', company.c.industry, company.c.company)
company_ix_sector   = Index('company_ix_sector',   company.c.sector,   company.c.industry, company.c.company)


eod = Table('eod', meta,
    Column('symbol', String, primary_key=True, nullable=False),
    Column('date', Date, primary_key=True, nullable=False),
    Column('o', Float),
    Column('h', Float),
    Column('l', Float),
    Column('c', Float),
    Column('v', BigInteger),
    Column('i', BigInteger),
    Column('ac', Float),
)
eod_ix_date = Index('eod_ix_date',  eod.c.date, postgresql_using='hash')


def upgrade(migrate_engine):
    meta.bind = migrate_engine
    company.create(meta.bind)
    eod.create(meta.bind)

def downgrade(migrate_engine):
    meta.bind = migrate_engine
    eod.drop(meta.bind)
    company.drop(meta.bind)
