class TestAPI:

    def test_dsn(self):
        import distcontrib.api as api
        url = 'postgresql://rgomes:secret@localhost/sample'
        m = api.dsn(url).check()
        assert(m['protocol'] == 'postgresql')
        assert(m['username'] == 'rgomes')
        assert(m['hostname'] == 'localhost')
        assert(m['port'] == 5432)
        assert(m['database'] == 'sample')
        assert(m['password'] == 'secret')
        assert(len(m['options']) == 0)

    def test_upgrade(self, changeset=None):
        url = 'sqlite:///build/pytest_upgrade.db'
        import distcontrib.api as api
        migrate = api.migrate(url, 'tests/guinea-pig/admin/migrate')
        migrate.set_verbose(True)
        migrate.upgrade()
        (model_version, database_version ) = migrate.status()
        assert(model_version == 2)
        assert(database_version == 2)


    def test_downgrade(self, changeset=None):
        url = 'sqlite:///build/pytest_downgrade.db'
        import distcontrib.api as api
        migrate = api.migrate(url, 'tests/guinea-pig/admin/migrate')
        migrate.set_verbose(True)
        migrate.upgrade()
        migrate.downgrade()
        (model_version, database_version ) = migrate.status()
        assert(model_version == 2)
        assert(database_version == 1)

    def test_sanity(self):
        url = 'sqlite:///build/pytest_sanitytest.db'
        import distcontrib.api as api
        migrate = api.migrate(url, 'tests/guinea-pig/admin/migrate')
        migrate.set_verbose(True)
        migrate.sanity()
        (model_version, database_version ) = migrate.status()
        assert(model_version == 2)
        assert(database_version == 0)
